package com.link.core.modules;

import com.link.core.modules.export.FileIndexGenarate;
import com.link.core.util.CoreYmlConstants;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;
import java.util.Random;
import java.util.Map.Entry;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class BatchExportFileWriter {

   private String filePath;
   private String urlPath;
   private String urlZipPath;
   private String ZipFilePath;
   private static final Logger logger = LogManager.getLogger(BatchExportFileWriter.class);
   private static Random RANDOM = new Random();
   private static ZipOutputStream outputStream;


   public String getUrlPath() {
      return this.urlPath;
   }

   public String getUrlZipPath() {
      return this.urlZipPath;
   }

   public void setUrlZipPath(String urlZipPath) {
      this.urlZipPath = urlZipPath;
   }

   public void setUrlPath(String urlPath) {
      this.urlPath = urlPath;
   }

   public String getFilePath() {
      return this.filePath;
   }

   public static void main(String[] args) {
   }

   public void initPath() {
      SimpleDateFormat dateFormatter = new SimpleDateFormat("yyyyMMdd");
      SimpleDateFormat datetimeFormatter = new SimpleDateFormat("yyyyMMddHHmmsss");
      String relatePath = "/export/" + dateFormatter.format(new Date()) + "/" + datetimeFormatter.format(new Date()) + "_" + FileIndexGenarate.getFileIndex(new Date()) + "_" + RANDOM.nextInt(100) + "/";
      File file = new File(CoreYmlConstants.getTemporaryIOFileDir() + relatePath);
      if(!file.exists() && !file.isDirectory()) {
         System.out.println("file: \'" + CoreYmlConstants.getTemporaryIOFileDir() + relatePath + "\' is not exists!");
         file.mkdirs();
      }

      this.setFilePath(CoreYmlConstants.getTemporaryIOFileDir2() + "/" + relatePath + "/");
      this.setUrlPath(CoreYmlConstants.getTemporaryIOUrlDir() + "/" + relatePath);
      String tempzipfile = RANDOM.nextInt(100) + ".zip";
      this.ZipFilePath = CoreYmlConstants.getTemporaryIOFileDir() + "/" + relatePath + "_" + tempzipfile;
      this.setUrlZipPath(CoreYmlConstants.getTemporaryIOUrlDir() + "/" + relatePath + "_" + tempzipfile);
   }

   public void setFilePath(String filePath) {
      this.filePath = filePath;
   }

   public String gettemplateContent(String Type) {
      String outstring = "";
      if("controller".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/templateController.java");
      } else if("user".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/template.java");
      } else if("service".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/templateService.java");
      } else if("serviceimpl".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/templateServiceImpl.java");
      } else if("mapper".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/templateMapper.java");
      } else if("mapperxml".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/templateMapper.xml");
      } else if("jsp".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/templatejsp.jsp");
      } else if("other".equals(Type)) {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + "/crm/other.txt");
      } else {
         outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + Type);
      }

      return outstring;
   }

   public String gettemplateContentByName(String fileName) {
      String outstring = "";
      outstring = this.readFileByLines(CoreYmlConstants.getTemplatePath() + fileName);
      return outstring;
   }

   public String readFileByLines(String fileName) {
      String FileContent = "";

      try {
         FileInputStream e = new FileInputStream(fileName);
         Throwable var4 = null;

         try {
            try {
               InputStreamReader e1 = new InputStreamReader(e, "UTF-8");
               Throwable var6 = null;

               try {
                  BufferedReader br = new BufferedReader(e1);
                  Throwable var8 = null;

                  try {
                     for(String line = null; (line = br.readLine()) != null; FileContent = FileContent + "\r\n") {
                        FileContent = FileContent + line;
                     }

                     e.close();
                     e1.close();
                  } catch (Throwable var58) {
                     var8 = var58;
                     throw var58;
                  } finally {
                     if(br != null) {
                        if(var8 != null) {
                           try {
                              br.close();
                           } catch (Throwable var57) {
                              var8.addSuppressed(var57);
                           }
                        } else {
                           br.close();
                        }
                     }

                  }
               } catch (Throwable var60) {
                  var6 = var60;
                  throw var60;
               } finally {
                  if(e1 != null) {
                     if(var6 != null) {
                        try {
                           e1.close();
                        } catch (Throwable var56) {
                           var6.addSuppressed(var56);
                        }
                     } else {
                        e1.close();
                     }
                  }

               }
            } catch (UnsupportedEncodingException var62) {
               logger.error("BatchExportFileWriter捕获异常: ", var62);
            }
         } catch (Throwable var63) {
            var4 = var63;
            throw var63;
         } finally {
            if(e != null) {
               if(var4 != null) {
                  try {
                     e.close();
                  } catch (Throwable var55) {
                     var4.addSuppressed(var55);
                  }
               } else {
                  e.close();
               }
            }

         }
      } catch (Exception var65) {
         logger.error("BatchExportFileWriter捕获异常: ", var65);
      }

      return FileContent;
   }

   public String readFileByLines3(String fileName) {
      String outstring = "";
      File file = new File(fileName);
      BufferedReader reader = null;

      try {
         reader = new BufferedReader(new FileReader(file));
         String e1 = null;

         for(int line = 1; (e1 = reader.readLine()) != null; ++line) {
            outstring = outstring + e1 + System.getProperty("line.separator");
         }

         reader.close();
      } catch (IOException var15) {
         logger.error("BatchExportFileWriter捕获异常: ", var15);
      } finally {
         if(reader != null) {
            try {
               reader.close();
            } catch (IOException var14) {
               logger.error("BatchExportFileWriter捕获异常: ", var14);
            }
         }

      }

      return outstring;
   }

   public void writeBatchText(Map filetext) {
      this.initPath();
      Iterator it = filetext.entrySet().iterator();

      while(it.hasNext()) {
         Entry entry = (Entry)it.next();
         Object key = entry.getKey();
         Object value = entry.getValue();
         String fileName = key.toString();
         String txt = value.toString();
         if(fileName.contains(".")) {
            int relPath = fileName.lastIndexOf(".");
            String relPathStringBuilder = fileName.substring(0, relPath);
            String file = this.filePath + relPathStringBuilder.replace(".", "/");
            File e = new File(file);
            if(!e.exists() && !e.isDirectory()) {
               System.out.println("file: \'" + file + "\' is not exists!");

               try {
                  e.mkdirs();
               } catch (Exception var39) {
                  logger.error("BatchExportFileWriter捕获异常: ", var39);
               }

               System.out.println("we create dir" + file);
            } else if(e.exists()) {
               System.out.println("--------we found : \'" + file + "\' is file!");
            } else {
               System.out.println("--------we found : \'" + file + "\' is dir!");
            }
         }

         String relPath1 = this.filePath + fileName.replace(".", "/").replace('#', '.');
         StringBuilder relPathStringBuilder1 = new StringBuilder(relPath1);
         File file1 = new File(relPath1);

         while(file1.isDirectory()) {
            relPathStringBuilder1.append("_1");
            file1 = new File(relPathStringBuilder1.toString());
            System.out.println("file: \'" + relPathStringBuilder1 + "\' is a Directory!");
         }

         try {
            FileOutputStream e2 = new FileOutputStream(relPath1);
            Throwable e1 = null;

            try {
               OutputStreamWriter osw = new OutputStreamWriter(e2, "UTF-8");
               Throwable var14 = null;

               try {
                  osw.write(txt);
                  osw.flush();
               } catch (Throwable var42) {
                  var14 = var42;
                  throw var42;
               } finally {
                  if(osw != null) {
                     if(var14 != null) {
                        try {
                           osw.close();
                        } catch (Throwable var41) {
                           var14.addSuppressed(var41);
                        }
                     } else {
                        osw.close();
                     }
                  }

               }
            } catch (Throwable var44) {
               e1 = var44;
               throw var44;
            } finally {
               if(e2 != null) {
                  if(e1 != null) {
                     try {
                        e2.close();
                     } catch (Throwable var40) {
                        e1.addSuppressed(var40);
                     }
                  } else {
                     e2.close();
                  }
               }

            }
         } catch (Exception var46) {
            logger.error("BatchExportFileWriter捕获异常: ", var46);
         }
      }

      writeMultiFileToZip(this.filePath, this.ZipFilePath, false);
   }

   public static void writeToZipFile(String folderPath) {
      writeToZipFile((File)(new File(folderPath)));
   }

   public static void writeToZipFile(File[] files) {
      int length = files.length;

      for(int i = 0; i < length; ++i) {
         writeToZipFile((File)files[i]);
      }

   }

   public static void writeToZipFile(File file) {
      if(file.exists()) {
         if(file.isFile()) {
            try {
               FileInputStream e = new FileInputStream(file);
               Throwable var2 = null;

               try {
                  BufferedInputStream bis = new BufferedInputStream(e);
                  Throwable var4 = null;

                  try {
                     logger.debug("压缩文件:" + file.getName());
                     ZipEntry entry = new ZipEntry(file.getName());
                     outputStream.putNextEntry(entry);
                     byte[] buffer = new byte[4096];

                     int length;
                     while((length = bis.read(buffer)) != -1) {
                        logger.debug("向压缩文件中写入数据大小：{}", Integer.valueOf(length));
                        outputStream.write(buffer, 0, length);
                     }
                  } catch (Throwable var31) {
                     var4 = var31;
                     throw var31;
                  } finally {
                     if(bis != null) {
                        if(var4 != null) {
                           try {
                              bis.close();
                           } catch (Throwable var30) {
                              var4.addSuppressed(var30);
                           }
                        } else {
                           bis.close();
                        }
                     }

                  }
               } catch (Throwable var33) {
                  var2 = var33;
                  throw var33;
               } finally {
                  if(e != null) {
                     if(var2 != null) {
                        try {
                           e.close();
                        } catch (Throwable var29) {
                           var2.addSuppressed(var29);
                        }
                     } else {
                        e.close();
                     }
                  }

               }
            } catch (IOException var35) {
               logger.error("把Excel文件写入压缩文件中出现异常：", var35);
            }
         } else {
            writeToZipFile((File[])file.listFiles());
         }
      } else {
         logger.error(file.getName() + "文件不存在");
      }

   }

   public void writeText1(String txt) {
      this.initPath();

      try {
         FileWriter e = new FileWriter(this.filePath);
         Throwable var3 = null;

         try {
            e.write(txt);
         } catch (Throwable var13) {
            var3 = var13;
            throw var13;
         } finally {
            if(e != null) {
               if(var3 != null) {
                  try {
                     e.close();
                  } catch (Throwable var12) {
                     var3.addSuppressed(var12);
                  }
               } else {
                  e.close();
               }
            }

         }
      } catch (IOException var15) {
         logger.error("BatchExportFileWriter捕获异常: ", var15);
      }

   }

   public void writeText(String txt) {
      this.initPath();
      OutputStreamWriter osw = null;

      try {
         osw = new OutputStreamWriter(new FileOutputStream(this.filePath, true), "UTF-8");
         osw.write(txt);
         osw.flush();
      } catch (UnsupportedEncodingException var16) {
         logger.error("BatchExportFileWriter捕获异常: ", var16);
      } catch (FileNotFoundException var17) {
         logger.error("BatchExportFileWriter捕获异常: ", var17);
      } catch (IOException var18) {
         logger.error("BatchExportFileWriter捕获异常: ", var18);
      } finally {
         if(osw != null) {
            try {
               osw.close();
            } catch (IOException var15) {
               logger.error("BatchExportFileWriter捕获异常: ", var15);
            }
         }

      }

      osw = null;
   }

   public static void writeMultiFileToZip(String filepath, String zippath, boolean dirFlag) {
      ZipOutputStream zipOut = null;

      try {
         File e = new File(filepath);
         File zipFile = new File(zippath);
         zipOut = new ZipOutputStream(new FileOutputStream(zipFile));
         if(e.isDirectory()) {
            File[] files = e.listFiles();
            File[] var7 = files;
            int var8 = files.length;

            for(int var9 = 0; var9 < var8; ++var9) {
               File fileSec = var7[var9];
               if(dirFlag) {
                  traversalFileToZip(zipOut, fileSec, e.getName() + File.separator);
               } else {
                  traversalFileToZip(zipOut, fileSec, "");
               }
            }
         } else if(e.isFile()) {
            traversalFileToZip(zipOut, e, "");
         }

         zipOut.close();
      } catch (Exception var19) {
         logger.error("BatchExportFileWriter捕获异常: ", var19);
      } finally {
         try {
            if(zipOut != null) {
               zipOut.close();
            }
         } catch (IOException var18) {
            logger.error("BatchExportFileWriter捕获异常: ", var18);
         }

      }

   }

   private static void traversalFileToZip(ZipOutputStream zipOut, File file, String baseDir) throws Exception {
      int len;
      if(file.isDirectory()) {
         File[] buf = file.listFiles();
         File[] e = buf;
         int var5 = buf.length;

         for(len = 0; len < var5; ++len) {
            File fileSec = e[len];
            traversalFileToZip(zipOut, fileSec, baseDir + file.getName() + File.separator);
         }
      } else {
         byte[] var19 = new byte[1024];

         try {
            FileInputStream var20 = new FileInputStream(file);
            Throwable var21 = null;

            try {
               zipOut.putNextEntry(new ZipEntry(baseDir + file.getName()));

               while((len = var20.read(var19)) != -1) {
                  zipOut.write(var19, 0, len);
               }
            } catch (Throwable var16) {
               var21 = var16;
               throw var16;
            } finally {
               if(var20 != null) {
                  if(var21 != null) {
                     try {
                        var20.close();
                     } catch (Throwable var15) {
                        var21.addSuppressed(var15);
                     }
                  } else {
                     var20.close();
                  }
               }

            }
         } catch (Exception var18) {
            var18.getStackTrace();
         }
      }

   }

}
